//+------------------------------------------------------------------+
//|                                                 painted macd.mq4 |
//|                                                           .....h |
//|                                                  ibfx forum crew |
//+------------------------------------------------------------------+
#property copyright ".....h"
#property link      "ibfx forum crew"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 6
#property  indicator_color1  Lime
#property  indicator_color2  Red
#property  indicator_color3  Lime
#property  indicator_color4  Red
#property  indicator_color5  Blue
#property  indicator_color6  White

//---- indicator parameters

extern int      fastema         = 12;  
extern int      slowema         = 26; 
extern int      signal          = 9;  



extern int      rviperiod       = 10;
extern double   rvithreshold    =  0;



double     ind_buffer1[];
double     ind_buffer2[];

int        HighBarBuffer[];
int        LowBarBuffer[];

//---- indicator buffers
double     CrossUp[];
double     CrossDown[];
double     CrossmacdUp[];
double     CrossmacdDown[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
 
  {

   //----
   IndicatorBuffers(8);
   
   //---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,2);
   
   SetIndexBuffer(2, HighBarBuffer);
   SetIndexBuffer(3, LowBarBuffer);

  
   
   
   SetIndexBuffer(4, CrossmacdUp);
   SetIndexStyle(4, DRAW_ARROW, EMPTY,3,Blue);
   SetIndexArrow(4, 233);
   
   SetIndexBuffer(5, CrossmacdDown);
   SetIndexStyle(5, DRAW_ARROW, EMPTY,3,White);
   SetIndexArrow(5, 234);
   
   
   
   
   
  IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
   
  
   if(!SetIndexBuffer(0,ind_buffer1) && !SetIndexBuffer(1,ind_buffer2)
   && !SetIndexBuffer(2,HighBarBuffer) && !SetIndexBuffer(3,LowBarBuffer))
      Print("cannot set indicator buffers!");
      
   
   //---- initialization done
   return(0);
   
  }
  
 //------------------------------------------------------------------
 int deinit()
   { 
   
   ObjectDelete("Label1");
    return(0);
   } 
 
 
 
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
  drawLabel("Label1"," macd painted",15,Lime,50,50,"Arial");
   int      limit,i,counter; 
   int      counted_bars=IndicatorCounted();
   double Range, AvgRange;
    //---- check for possible errors
   if(counted_bars<0) return(-1);
   
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   //----Calculation---------------------------
   for( i=0; i<limit; i++)
   {
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+9;counter++) {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
    Range      =AvgRange/10;
    
    double macd        = iMACD(NULL,0,fastema,slowema,signal,PRICE_CLOSE,MODE_MAIN,i);
    double macdsig     = iMACD(NULL,0,fastema,slowema,signal,PRICE_CLOSE,MODE_SIGNAL,i);
    double macd2       = iMACD(NULL,0,fastema,slowema,signal,PRICE_CLOSE,MODE_MAIN,i+1);
    double macdsig2    = iMACD(NULL,0,fastema,slowema,signal,PRICE_CLOSE,MODE_SIGNAL,i+1);
                              
    double daymacd     = iMACD(NULL,       1440,  12, 26, 9, 0, 0, i);
    double daymacdsig  = iMACD(NULL,       1440,  12, 26, 9, 0, 1, i);
    double daymacd2    = iMACD(NULL,       1440,  12, 26, 9, 0, 0, i+1);
    double daymacdsig2 = iMACD(NULL,       1440,  12, 26, 9, 0, 1, i+1);
    
    
    double rvi =iRVI(NULL, 0,rviperiod,MODE_MAIN,i);
    double rvi1 =iRVI(NULL, 0,rviperiod,MODE_MAIN,i+1);
       
      if(macd>macdsig && daymacd > daymacdsig) 
       {
         ind_buffer2[i]=Low[i];
         ind_buffer1[i]=High[i];
       }

      if(macdsig>macd &&  daymacdsig > daymacd) 
       {
         ind_buffer1[i]=Low[i];
         ind_buffer2[i]=High[i];
       }
     
      
      
     if ((macd > macdsig) && (macd2 < macdsig2) && macd < 0)
      {
         CrossmacdUp[i] =Low[i] - Range*1;
      }
      else if ((macd < macdsig) && (macd2 > macdsig2) && macd > 0)
      {
        CrossmacdDown[i] = High[i] + Range*1;
      }
      }
      
      
      
   
      
   //---- done

   return(0);
  }
  
  void drawLabel(string id, string text,int fsize, color fcolor,int x,int y,string font="Arial",int window = 0)
{
      if(ObjectFind(id)==-1)
      { 
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 0);
        ObjectSet(id, OBJPROP_XDISTANCE, x);
        ObjectSet(id, OBJPROP_YDISTANCE, y);
      }
      else
      {
        
        ObjectDelete(id);
         
        ObjectCreate(id, OBJ_LABEL, window, 0, 0);
        ObjectSetText(id,text, fsize, font, fcolor);
        ObjectSet(id, OBJPROP_CORNER, 0);
        ObjectSet(id, OBJPROP_XDISTANCE, x);
        ObjectSet(id, OBJPROP_YDISTANCE, y);   
      }  
}